/*
 *				**** DEFINE ****
 *
 * This file defines global variables
 *
 */

#define	EXTERN

#include "quiz.h"

FILE *
get_quiz(char *buf)
{
	FILE	*fp;

	do
	{		/* get quiz file */
		if (*buf != '\0')
		{
			if ((fp = fopen(buf,"r")) == NULL)
				printf("Can't open file %s!\n", buf);
		} else fp = NULL;

		if (fp == NULL)
		{		/* no quiz file yet */
			printf("Enter quiz file name, or ENTER to quit: ");
			gets(buf);
			if (*buf == '\0') exit(0);
		}
	} while (fp == NULL);

	load_quiz(fp);

	printf("%d questions found in %s\n", TotQuest, buf);

	return fp;
}

load_quiz(FILE *fp)
{		/* load Quiz struct from file fp */
	char	buf[BUFSIZ];		/* input buffer */
	long	floc = 0L;			/* file seek location */
	int		quest = 1;			/* looking for question */

	TotQuest = 0;				/* no questions so far */

	while (get_line(buf,BUFSIZ,fp))
	{		/* line read */
		if (quest)
		{
			if (*buf == '\0') continue;	/* skip blank lines */
			/* new question - save Q & A locations  */
			Quiz[TotQuest].q_w = floc;			/* start of word */
			Quiz[TotQuest].q_d = ftell(fp);		/* start of definition */
			TotQuest++;							/* incr. counter */
			quest = 0;		/* not looking for question anymore */
		}

		if (*buf == '\0') quest++;

		floc = ftell(fp);
	}
}

get_line(char *buf, int siz, FILE *fp)
{
	if (fgets(buf,siz,fp) == NULL) return 0;		/* EOF */
	while (*buf != '\r' && *buf != '\n' && *buf != '\0') buf++;
	*buf = '\0';
	return 1;
}

get_nums(int num)
{
	int		i, j;		/* loop variable */

	for (i=0; i < num; i++)
	{		/* loop to select numbers */
		Nums[i] = random(TotQuest);		/* get random number */
		for (j=0; j < i; j++)
		{		/* make sure number is unique */
			if (Nums[j] == Nums[i])
			{		/* duplicate - drop last number */
				i--;		/* decrement number selected */
				break;
			}
		}
	}
}

put_line(FILE *ifp, FILE *ofp, long loc)
{
	char	buf[BUFSIZ];
    char *p, *q;

	fseek(ifp,loc,SEEK_SET);
	fgets(buf,BUFSIZ,ifp);
	for (p=buf; *p != '\0' && *p != '\n' && *p != '\r'; p++);
	*p = '\0';

	for (p=buf; p != NULL && *p != '\0'; p = q)
	{ /* print line in segments if too long */
		if (strlen(p) < right_margin) q = NULL;	/* short enough */
		else for (q = p + right_margin - 1; q > p && ! isspace(*q); q--);
		if (q > p) *q++ = '\0'; else q = NULL;	/* terminate long line */
		fputs(p,ofp);
		fputc('\n', ofp);
	}
}

do_help(void)
{
	char buf[BUFSIZ];

	printf("Press ENTER to see the help file.  Press ESC to quit help: ");
	gets(buf);
	system("LIST QUIZ.HLP");
	printf("Press ENTER to return to main menu: ");
	gets(buf);
}

char *
copy_string(char *str)
{
	char *ret;

	ret = (char *) malloc(strlen(str)+1);
	strcpy(ret, str);
	return ret;
}
